﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;
using System.Windows.Shapes;

namespace TowerDefender.Graphics
{
    public class MapManager
    {
        Window _w;
        Entities.Map _m;

        public MapManager (Window w, Entities.Map m)
    	{
            _w = w;
            _m = m;
	    }


        public Grid CreateMap()
        {
            Grid g = new Grid();
            _w.Content = g;
            g.Width = _w.Width;
            g.Height = _w.Height;
            g.Background = Brushes.Green;

            for (int i = 0; i < _m.Width; i++)
            {
                var c = new ColumnDefinition();
                g.ColumnDefinitions.Add(c);
            }
            for (int j = 0; j < _m.Length; j++)
            {
                var r = new RowDefinition();
                g.RowDefinitions.Add(r);
            }


            foreach (var step in _m.MapPath.Steps)
            {
                Rectangle r = new Rectangle();

                r.Fill = new SolidColorBrush(Colors.Gray);
                r.SetValue(Grid.ColumnProperty, step.X - 1);
                r.SetValue(Grid.RowProperty, step.Y - 1);
                g.Children.Add(r);
            }
            return g;
        }
    }
}
